library IEEE;
use IEEE.Std_logic_1164.all;

entity Practica4_TB is
end;

architecture BENCH of Practica4_TB is
  signal Ready,Entrada_codi,Tecla,P_oberta,P_tancada : Std_logic;
  signal Clock, Reset : Std_logic;
  signal StopClock : BOOLEAN;
  signal Entrada : Std_logic_vector(9 downto 0);
  
begin
  M: entity work.Practica4(RTL) port map (
        Ready =>Ready,
        Entrada_codi =>Entrada_codi,
        Tecla =>Tecla,
        P_oberta =>P_oberta,
        P_tancada =>P_tancada,
        Entrada => Entrada,
        Reset => Reset,
        Clock => Clock
        );

  process
  begin
    while not StopClock loop
      Clock <= '0';
      wait for 5 ns;
      Clock <= '1';
      wait for 5 ns;
    end loop;
    wait;
  end process;
  
  process
  begin
    Reset <= '0';
    Entrada <= "0000000000";
    wait for 50 ns;

    assert Ready='1' and  Tecla='0' and Entrada_codi='0' and P_oberta='0' and P_tancada='0'  report "Incorrecte";
    
    Entrada <= "0000000100";
    wait for 50 ns;
    assert Ready='0' and  Tecla='1' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000000000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='0' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000001000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='1' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000000000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='0' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000100000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='1' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000000000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='0' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";
    
    Entrada <= "0000000010";
    wait for 50 ns;
    assert Ready='0' and  Tecla='1' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000000000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='0' and Entrada_codi='0' and P_oberta='1' and P_tancada='0'  report "Incorrecte";

    Reset <= '1';
    Entrada <= "0000000000";
    wait for 50 ns;
    Reset <= '0';
    wait for 50 ns;

    assert Ready='1' and  Tecla='0' and Entrada_codi='0' and P_oberta='0' and P_tancada='0'  report "Incorrecte";
    
    Entrada <= "0000000010";
    wait for 50 ns;
    assert Ready='0' and  Tecla='1' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000000000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='0' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000000100";
    wait for 50 ns;
    assert Ready='0' and  Tecla='1' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000000000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='0' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000010000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='1' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000000000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='0' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";
    
    Entrada <= "0000000100";
    wait for 50 ns;
    assert Ready='0' and  Tecla='1' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000000000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='0' and Entrada_codi='0' and P_oberta='0' and P_tancada='1'  report "Incorrecte";

    Reset <= '1';
    Entrada <= "0000000000";
    wait for 50 ns;
    Reset <= '0';
    wait for 50 ns;

    assert Ready='1' and  Tecla='0' and Entrada_codi='0' and P_oberta='0' and P_tancada='0'  report "Incorrecte";
    
    Entrada <= "0000000100";
    wait for 50 ns;
    assert Ready='0' and  Tecla='1' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000000000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='0' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000000100";
    wait for 50 ns;
    assert Ready='0' and  Tecla='1' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000000000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='0' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000010000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='1' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000000000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='0' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";
    
    Entrada <= "0000000100";
    wait for 50 ns;
    assert Ready='0' and  Tecla='1' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000000000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='0' and Entrada_codi='0' and P_oberta='0' and P_tancada='1'  report "Incorrecte";

    Reset <= '1';
    Entrada <= "0000000000";
    wait for 50 ns;
    Reset <= '0';
    wait for 50 ns;

    assert Ready='1' and  Tecla='0' and Entrada_codi='0' and P_oberta='0' and P_tancada='0'  report "Incorrecte";
    
    Entrada <= "0000000100";
    wait for 50 ns;
    assert Ready='0' and  Tecla='1' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000000000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='0' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000001000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='1' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000000000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='0' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000010000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='1' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000000000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='0' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";
    
    Entrada <= "0000000100";
    wait for 50 ns;
    assert Ready='0' and  Tecla='1' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000000000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='0' and Entrada_codi='0' and P_oberta='0' and P_tancada='1'  report "Incorrecte";

    Reset <= '1';
    Entrada <= "0000000000";
    wait for 50 ns;
    Reset <= '0';
    wait for 50 ns;

    assert Ready='1' and  Tecla='0' and Entrada_codi='0' and P_oberta='0' and P_tancada='0'  report "Incorrecte";
    
    Entrada <= "0000000100";
    wait for 50 ns;
    assert Ready='0' and  Tecla='1' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000000000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='0' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000001000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='1' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000000000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='0' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000100000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='1' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000000000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='0' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";
    
    Entrada <= "0000000100";
    wait for 50 ns;
    assert Ready='0' and  Tecla='1' and Entrada_codi='1' and P_oberta='0' and P_tancada='0'  report "Incorrecte";

    Entrada <= "0000000000";
    wait for 50 ns;
    assert Ready='0' and  Tecla='0' and Entrada_codi='0' and P_oberta='0' and P_tancada='1'  report "Incorrecte";

    StopClock <= TRUE;
    wait;
  end process;  
end;

